Name:           ros2-iron-rviz_visual_tools
Version:        4.1.4
Release:        1%{?dist}
Summary:        ROS package rviz_visual_tools

License:        BSD
URL:            https://github.com/PickNikRobotics/rviz_visual_tools

Source0:        https://github.com/ros2-gbp/rviz_visual_tools-release/archive/release/iron/rviz_visual_tools/4.1.4-3.tar.gz#/ros2-iron-rviz_visual_tools-4.1.4-source0.tar.gz



# common BRs
BuildRequires: patchelf
BuildRequires: cmake
BuildRequires: gcc-c++
BuildRequires: git
BuildRequires: make
BuildRequires: patch
BuildRequires: python3-devel
BuildRequires: python-unversioned-command
BuildRequires: python3-colcon-common-extensions
BuildRequires: python3-pip
BuildRequires: python3-pydocstyle
BuildRequires: python3-pytest
BuildRequires: python3-pytest-repeat
BuildRequires: python3-pytest-rerunfailures
BuildRequires: python3-rosdep
BuildRequires: python3-setuptools
BuildRequires: python3-vcstool

# BuildRequires:  boost-devel
# BuildRequires:  console-bridge-devel
# BuildRequires:  gtest-devel
# BuildRequires:  log4cxx-devel
# BuildRequires:  python3-devel
# BuildRequires:  python3-colcon-common-extensions
# BuildRequires:  python-unversioned-command

BuildRequires:  eigen3-devel
BuildRequires:  qt5-qtbase-devel
BuildRequires:  ros2-iron-ament_cmake-devel
BuildRequires:  ros2-iron-ament_cmake_gtest-devel
BuildRequires:  ros2-iron-ament_lint_auto-devel
BuildRequires:  ros2-iron-ament_lint_common-devel
BuildRequires:  ros2-iron-ament_package-devel
BuildRequires:  ros2-iron-eigen3_cmake_module-devel
BuildRequires:  ros2-iron-eigen_stl_containers-devel
BuildRequires:  ros2-iron-geometry_msgs-devel
BuildRequires:  ros2-iron-interactive_markers-devel
BuildRequires:  ros2-iron-pluginlib-devel
BuildRequires:  ros2-iron-rclcpp-devel
BuildRequires:  ros2-iron-rclcpp_components-devel
BuildRequires:  ros2-iron-rviz_common-devel
BuildRequires:  ros2-iron-rviz_default_plugins-devel
BuildRequires:  ros2-iron-rviz_ogre_vendor-devel
BuildRequires:  ros2-iron-rviz_rendering-devel
BuildRequires:  ros2-iron-sensor_msgs-devel
BuildRequires:  ros2-iron-shape_msgs-devel
BuildRequires:  ros2-iron-std_msgs-devel
BuildRequires:  ros2-iron-tf2-devel
BuildRequires:  ros2-iron-tf2_eigen-devel
BuildRequires:  ros2-iron-tf2_geometry_msgs-devel
BuildRequires:  ros2-iron-trajectory_msgs-devel
BuildRequires:  ros2-iron-visualization_msgs-devel

Requires:       qt5-qtbase
Requires:       ros2-iron-ament_index_python
Requires:       ros2-iron-eigen_stl_containers
Requires:       ros2-iron-geometry_msgs
Requires:       ros2-iron-interactive_markers
Requires:       ros2-iron-launch
Requires:       ros2-iron-launch_ros
Requires:       ros2-iron-pluginlib
Requires:       ros2-iron-rclcpp
Requires:       ros2-iron-rclcpp_components
Requires:       ros2-iron-rviz2
Requires:       ros2-iron-rviz_common
Requires:       ros2-iron-rviz_default_plugins
Requires:       ros2-iron-rviz_ogre_vendor
Requires:       ros2-iron-rviz_rendering
Requires:       ros2-iron-sensor_msgs
Requires:       ros2-iron-shape_msgs
Requires:       ros2-iron-std_msgs
Requires:       ros2-iron-tf2
Requires:       ros2-iron-tf2_eigen
Requires:       ros2-iron-tf2_geometry_msgs
Requires:       ros2-iron-trajectory_msgs
Requires:       ros2-iron-visualization_msgs

Provides:  ros2-iron-rviz_visual_tools = 4.1.4-1
Obsoletes: ros2-iron-rviz_visual_tools < 4.1.4-1



%description
Utility functions for displaying and debugging data in Rviz via
published markers

%package        devel
Summary:        Development files for %{name}
Requires:       %{name}%{?_isa} = %{version}-%{release}
Requires:       eigen3-devel
Requires:       ros2-iron-ament_cmake-devel
Requires:       ros2-iron-eigen3_cmake_module-devel
Requires:       qt5-qtbase-devel
Requires:       ros2-iron-ament_cmake_gtest-devel
Requires:       ros2-iron-ament_lint_auto-devel
Requires:       ros2-iron-ament_lint_common-devel
Requires:       ros2-iron-ament_package-devel
Requires:       ros2-iron-eigen_stl_containers-devel
Requires:       ros2-iron-geometry_msgs-devel
Requires:       ros2-iron-interactive_markers-devel
Requires:       ros2-iron-pluginlib-devel
Requires:       ros2-iron-rclcpp-devel
Requires:       ros2-iron-rclcpp_components-devel
Requires:       ros2-iron-rviz_common-devel
Requires:       ros2-iron-rviz_default_plugins-devel
Requires:       ros2-iron-rviz_ogre_vendor-devel
Requires:       ros2-iron-rviz_rendering-devel
Requires:       ros2-iron-sensor_msgs-devel
Requires:       ros2-iron-shape_msgs-devel
Requires:       ros2-iron-std_msgs-devel
Requires:       ros2-iron-tf2-devel
Requires:       ros2-iron-tf2_eigen-devel
Requires:       ros2-iron-tf2_geometry_msgs-devel
Requires:       ros2-iron-trajectory_msgs-devel
Requires:       ros2-iron-visualization_msgs-devel
Requires:       ros2-iron-ament_index_python-devel
Requires:       ros2-iron-launch-devel
Requires:       ros2-iron-launch_ros-devel
Requires:       ros2-iron-rviz2-devel

Provides: ros2-iron-rviz_visual_tools-devel = 4.1.4-1
Obsoletes: ros2-iron-rviz_visual_tools-devel < 4.1.4-1


%description devel
The %{name}-devel package contains libraries and header files for developing
applications that use %{name}.



%prep

%setup -c -T
tar --strip-components=1 -xf %{SOURCE0}

%build
# nothing to do here


%install

PYTHONUNBUFFERED=1 ; export PYTHONUNBUFFERED
GZ_BUILD_FROM_SURCE=1; export GZ_BUILD_FROM_SOURCE

CFLAGS=" -Wno-error ${CFLAGS:-%optflags} -Wno-error -w -Wno-error=int-conversion" ; export CFLAGS ; \
CXXFLAGS=" -Wno-error ${CXXFLAGS:-%optflags} -Wno-error -w -Wno-error=int-conversion" ; export CXXFLAGS ; \
FFLAGS=" -Wno-error ${FFLAGS:-%optflags%{?_fmoddir: -I%_fmoddir}} -w -Wno-error=int-conversion" ; export FFLAGS ; \
FCFLAGS="${FCFLAGS:-%optflags%{?_fmoddir: -I%_fmoddir}} -w -Wno-error=int-conversion" ; export FCFLAGS ; \
%{?__global_ldflags:LDFLAGS="${LDFLAGS:-%__global_ldflags}" ; export LDFLAGS ;} \

source %{_libdir}/ros2-iron/setup.bash

# substitute shebang before install block because we run the local catkin script
%py3_shebang_fix .

# DESTDIR=%{buildroot} ; export DESTDIR


colcon \
  build \
  --merge-install \
  --cmake-args -DPYTHON_EXECUTABLE="/usr/bin/python" \
  -DTHIRDPARTY_Asio=ON \
  -DCMAKE_BUILD_TYPE=RelWithDebInfo \
  -DCMAKE_CXX_FLAGS="$CXXFLAGS" \
  -DCMAKE_C_FLAGS="$CFLAGS" \
  -DCMAKE_LD_FLAGS="$LDFLAGS" \
  -DBUILD_TESTING=OFF \
  --base-paths . \
  --install-base %{buildroot}/%{_libdir}/ros2-iron/ \
  --packages-select rviz_visual_tools



# remove wrong buildroot prefixes
find %{buildroot}/%{_libdir}/ros2-iron/ -type f -exec sed -i "s:%{buildroot}::g" {} \;

# # Move include directory if source path exists
# if [ -d %{buildroot}/%{_libdir}/ros2-iron/opt/rviz_visual_tools/include ]; then
#     # If destination path does not exist, create it
#     if [ ! -d %{buildroot}/%{_libdir}/ros2-iron/include/rviz_visual_tools ]; then
#         mkdir -p %{buildroot}/%{_libdir}/ros2-iron/include/rviz_visual_tools
#     fi
#     # Move the directory
#     mv -f %{buildroot}/%{_libdir}/ros2-iron/opt/rviz_visual_tools/include/* %{buildroot}/%{_libdir}/ros2-iron/include/rviz_visual_tools
# fi
# 
# # Move share directory if source path exists
# if [ -d %{buildroot}/%{_libdir}/ros2-iron/opt/rviz_visual_tools/share ]; then
#     # If destination path does not exist, create it
#     if [ ! -d %{buildroot}/%{_libdir}/ros2-iron/share ]; then
#         mkdir -p %{buildroot}/%{_libdir}/ros2-iron/share
#     fi
#     # Move the directory
#     mv -f %{buildroot}/%{_libdir}/ros2-iron/opt/rviz_visual_tools/share %{buildroot}/%{_libdir}/ros2-iron/
#     find %{buildroot}/%{_libdir}/ros2-iron/share -type f -exec sed -i "s:opt/rviz_visual_tools/::g" {} \;
# fi
# 
# # Move bin directory if source path exists
# if [ -d %{buildroot}/%{_libdir}/ros2-iron/opt/rviz_visual_tools/bin ]; then
#     # If destination path does not exist, create it
#     if [ ! -d %{buildroot}/%{_libdir}/ros2-iron/bin ]; then
#         mkdir -p %{buildroot}/%{_libdir}/ros2-iron/bin
#     fi
#     # Move the directory
#     mv -f %{buildroot}/%{_libdir}/ros2-iron/opt/rviz_visual_tools/bin %{buildroot}/%{_libdir}/ros2-iron/
# fi
# 
# # Move extra_cmake directory if source path exists
# if [ -d %{buildroot}/%{_libdir}/ros2-iron/opt/rviz_visual_tools/extra_cmake ]; then
#     # If destination path does not exist, create it
#     if [ ! -d %{buildroot}/%{_libdir}/ros2-iron/extra_cmake ]; then
#         mkdir -p %{buildroot}/%{_libdir}/ros2-iron/extra_cmake
#     fi
#     # Move the directory
#     mv -f %{buildroot}/%{_libdir}/ros2-iron/opt/rviz_visual_tools/extra_cmake %{buildroot}/%{_libdir}/ros2-iron/
#     find %{buildroot}/%{_libdir}/ros2-iron/extra_cmake -type f -exec sed -i "s:opt/rviz_visual_tools/::g" {} \;
# fi
# 
# # Move lib directory if source path exists
# if [ -d %{buildroot}/%{_libdir}/ros2-iron/opt/rviz_visual_tools/lib ]; then
#     # If destination path does not exist, create it
#     if [ ! -d %{buildroot}/%{_libdir}/ros2-iron/lib ]; then
#         mkdir -p %{buildroot}/%{_libdir}/ros2-iron/lib
#     fi
#     # Move the directory
#     mv -f %{buildroot}/%{_libdir}/ros2-iron/opt/rviz_visual_tools/lib %{buildroot}/%{_libdir}/ros2-iron/lib
# fi
# 
# # Move lib64 directory if source path exists
# if [ -d %{buildroot}/%{_libdir}/ros2-iron/opt/rviz_visual_tools/lib64 ]; then
#     # If destination path does not exist, create it
#     if [ ! -d %{buildroot}/%{_libdir}/ros2-iron/lib64 ]; then
#         mkdir -p %{buildroot}/%{_libdir}/ros2-iron/lib64
#     fi
#     # Move the directory
#     mv -f %{buildroot}/%{_libdir}/ros2-iron/opt/rviz_visual_tools/lib64 %{buildroot}/%{_libdir}/ros2-iron/lib64
# fi

rm -rf %{buildroot}/%{_libdir}/ros2-iron/{.catkin,.rosinstall,_setup*,local_setup*,setup*,env.sh,.colcon_install_layout,COLCON_IGNORE,_local_setup*,_local_setup*}

# remove __pycache__
find %{buildroot} -type d -name '__pycache__' -exec rm -rf {} +
find . -name '*.pyc' -delete

touch files.list
find %{buildroot}/%{_libdir}/ros2-iron/{opt,bin,etc,tools,lib64/python*,lib/python*/site-packages,share} \
  -mindepth 1 -maxdepth 1 | sed "s:%{buildroot}/::" > files.list
find %{buildroot}/%{_libdir}/ros2-iron/lib*/ -mindepth 1 -maxdepth 1 \
  ! -name pkgconfig ! -name "python*" \
  | sed "s:%{buildroot}/::" >> files.list

touch files_devel.list
find %{buildroot}/%{_libdir}/ros2-iron/{lib*/pkgconfig,include/,cmake/,rviz_visual_tools/include/,share/rviz_visual_tools/cmake} \
  -mindepth 1 -maxdepth 1 | sed "s:%{buildroot}/::" > files_devel.list

find . -maxdepth 1 -type f -iname "*readme*" | sed "s:^:%%doc :" >> files.list
find . -maxdepth 1 -type f -iname "*license*" | sed "s:^:%%license :" >> files.list



find %{buildroot}/%{_libdir}/ros2-iron/ -name *__rosidl_generator_py.so -type f -exec patchelf --remove-rpath  {} \;
# find %{buildroot}/%{_libdir}/ros2-iron/ -name *__rosidl_generator_py.so -type f -exec patchelf --force-rpath --add-rpath "%{_libdir}/ros2/lib" {} \;

# replace cmake python macro in shebang
for file in $(grep -rIl '^#!.*@PYTHON_EXECUTABLE@.*$' %{buildroot}) ; do
  sed -i.orig 's:^#!\s*@PYTHON_EXECUTABLE@\s*:%{__python3}:' $file
  touch -r $file.orig $file
  rm $file.orig
done


echo "This is a package automatically generated with rosfed." >> README_FEDORA
echo "See  https://github.com/morxa/rosfed for more information." >> README_FEDORA
install -m 0644 -p -D -t %{buildroot}/%{_docdir}/%{name} README_FEDORA
echo %{_docdir}/%{name} >> files.list
install -m 0644 -p -D -t %{buildroot}/%{_docdir}/%{name}-devel README_FEDORA
echo %{_docdir}/%{name}-devel >> files_devel.list

%py3_shebang_fix %{buildroot}

# Also fix .py.in files
for pyfile in $(grep -rIl '^#!.*python.*$' %{buildroot}) ; do
  %py3_shebang_fix $pyfile
done


%files -f files.list
%files devel -f files_devel.list


%changelog
* Fri Apr 26 2024 Tarik Viehmann <viehmann@kbsg.rwth-aachen.de> - iron.4.1.4-1
- Update to latest release
